/**
 * \file api.h
 * \brief NIST KEM API used by the Ouroboros-R scheme
 */


#ifndef API_H
#define API_H


#define CRYPTO_ALGNAME "Ouroboros-R-128"

#define CRYPTO_SECRETKEYBYTES 40
#define CRYPTO_PUBLICKEYBYTES 2812
#define CRYPTO_BYTES 64
#define CRYPTO_CIPHERTEXTBYTES 3672


int crypto_kem_keypair(unsigned char* pk, unsigned char* sk);
int crypto_kem_enc(unsigned char* ct, unsigned char* ss, const unsigned char* pk);
int crypto_kem_dec(unsigned char* ss, const unsigned char* ct, const unsigned char* sk);

#endif

/*
#define CRYPTO_SECRETKEYBYTES SEEDEXPANDER_SEED_BYTES
#define CRYPTO_PUBLICKEYBYTES PARAM_N * PARAM_N1 * (PARAM_M / 8 + 1) + SEEDEXPANDER_SEED_BYTES
#define CRYPTO_BYTES SHA512_BYTES
#define CRYPTO_CIPHERTEXTBYTES PARAM_N2 * PARAM_N * (PARAM_M / 8 + 1) + PARAM_N2 * PARAM_N1 * (PARAM_M / 8 + 1)
*/
